function op = smooth_Logistic( X, y )
% SMOOTH_LOGISTIC Logistic Regression function: sum_i( log( 1+exp(y_i*w_i) ) )
%   OP = SMOOTH_LOGLLOGISTIC( Y )
%   returns a function that computes the logistic regression function

error(nargchk(2,2,nargin));
op = tfocs_smooth( @smooth_logistic_impl);

function [ v, g ] = smooth_logistic_impl( mu )

  v = sum(log(1 + exp(-y.*(X*mu))));  
 
  if nargout > 1,
    Xmu  = X*mu;
    yXmu = y.*Xmu;

    t = 1./(1+exp(-yXmu));
    g = X'*(y.*(t - 1));
  end
end

end
  
% TFOCS v1.3 by Stephen Becker, Emmanuel Candes, and Michael Grant.
% Copyright 2013 California Institute of Technology and CVX Research.
% See the file LICENSE for full license information.