%DEMO_USE_FCN Demonstrates the usage of the optional function handle
%user_fcn for solver pdNCG. The usage of this parameter is demonstrated on
%a least-squares problem:
%
%  min tau*||x||_1 + 0.5||Ax-b||_2^2.

clear;

% Load a problem (A,b,xopt,fvalOpt), where its optimal solution xopt is
% given for tau = 1.0.
load data_ls.mat

[~, n] = size(A);

% Options.
opts.problem = 'ls';
opts.n = n;
opts.tau  = 1.0;
opts.verbose = 0;

% display rellative error of solution at every iteration.
opts.user_fcn = @(options,primal,dual,f,g,H,P,d) disp(norm(primal-xopt)/norm(xopt));

opts.A = A;
opts.b = b;

% Call pdNCG.
[x, y, out] = pdNCGinterface(opts);

fprintf('Elapsed time: %d \n', out.time);

fprintf('Rellative error: %d \n', norm(x-xopt)/norm(xopt));

clear;